diff --git a/hid-xpadneo/src/hid-xpadneo.c b/hid-xpadneo/src/hid-xpadneo.c
index f0a31f0d..037dc1b4 100644
--- a/hid-xpadneo/src/hid-xpadneo.c
+++ b/hid-xpadneo/src/hid-xpadneo.c
@@ -80,6 +80,7 @@ MODULE_PARM_DESC(gamepad_compliance,
 #define XPADNEO_QUIRK_NO_TRIGGER_RUMBLE 2
 #define XPADNEO_QUIRK_NO_MOTOR_MASK     4
 #define XPADNEO_QUIRK_USE_HW_PROFILES   8
+#define XPADNEO_QUIRK_LINUX_BUTTONS     16
 
 static struct {
 	char *args[17];
@@ -92,7 +93,8 @@ MODULE_PARM_DESC(quirks,
 		 ", no pulse parameters = " __stringify(XPADNEO_QUIRK_NO_PULSE)
 		 ", no trigger rumble = " __stringify(XPADNEO_QUIRK_NO_TRIGGER_RUMBLE)
 		 ", no motor masking = " __stringify(XPADNEO_QUIRK_NO_MOTOR_MASK)
-		 ", hardware profile switch = " __stringify(XPADNEO_QUIRK_USE_HW_PROFILES));
+		 ", hardware profile switch = " __stringify(XPADNEO_QUIRK_USE_HW_PROFILES)
+		 ", use Linux button mappings = " __stringify(XPADNEO_QUIRK_LINUX_BUTTONS));
 
 static DEFINE_IDA(xpadneo_device_id_allocator);
 
@@ -836,7 +838,9 @@ static u8 *xpadneo_report_fixup(struct hid_device *hdev, u8 *rdesc, unsigned int
 		    rdesc[144] == 0x29 && rdesc[145] == 0x0F &&
 		    rdesc[152] == 0x95 && rdesc[153] == 0x0F &&
 		    rdesc[162] == 0x95 && rdesc[163] == 0x01) {
+			struct xpadneo_devdata *xdata = hid_get_drvdata(hdev);
 			hid_notice(hdev, "fixing up button mapping\n");
+			xdata->quirks |= XPADNEO_QUIRK_LINUX_BUTTONS;
 			rdesc[145] = 0x0B;	/* 15 buttons -> 11 buttons */
 			rdesc[153] = 0x0B;	/* 15 bits -> 11 bits buttons */
 			rdesc[163] = 0x05;	/* 1 bit -> 5 bits constants */
@@ -870,7 +874,7 @@ static int xpadneo_raw_event(struct hid_device *hdev, struct hid_report *report,
 	}
 
 	/* correct button mapping of Xbox controllers in Linux mode */
-	if (report->id == 1 && (reportsize == 17 || reportsize == 39 || reportsize == 55)) {
+	if ((xdata->quirks & XPADNEO_QUIRK_LINUX_BUTTONS) && report->id == 1 && reportsize >= 17) {
 		u16 bits = 0;
 
 		bits |= (data[14] & (BIT(0) | BIT(1))) >> 0;	/* A, B */
@@ -1121,6 +1125,7 @@ static int xpadneo_probe(struct hid_device *hdev, const struct hid_device_id *id
 		return -ENOMEM;
 
 	xdata->id = ida_simple_get(&xpadneo_device_id_allocator, 0, 0, GFP_KERNEL);
+	xdata->quirks = id->driver_data;
 
 	xdata->hdev = hdev;
 	hid_set_drvdata(hdev, xdata);
@@ -1137,7 +1142,6 @@ static int xpadneo_probe(struct hid_device *hdev, const struct hid_device_id *id
 		return ret;
 	}
 
-	xdata->quirks = id->driver_data;
 	ret = xpadneo_init_hw(hdev);
 	if (ret) {
 		hid_err(hdev, "hw init failed: %d\n", ret);
